﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter2
{
    public class ImportantData { }

    public class MyBusinessObject
    {
        public MyBusinessObject()
        {
            // Read Only property providing access to a
            // private data member:
            Data = new BindingList<ImportantData>();
        }

        public BindingList<ImportantData> Data { get; }
        // other details elided
    }

    public class Item17
    {
        public static void Tests()
        {
            MyBusinessObject bizObj = new MyBusinessObject();

            // Access the collection:
            BindingList<ImportantData> stuff = bizObj.Data;
            // Not intended, but allowed:
            stuff.Clear(); // Deletes all data.


        }
    }

    namespace PartTwo
    {
        public class MyBusinessObject
        {
            // Read Only property providing access to a
            // private data member:
            private BindingList<ImportantData> listOfData = new
                BindingList<ImportantData>();
            public IBindingList BindingData =>
                listOfData;

            public ICollection<ImportantData> CollectionOfData =>
                listOfData;
            // other details elided
        }

    }

    namespace PartThree
    {
        public class MyBusinessObject
        {
            // Read Only property providing access to a
            // private data member:
            private BindingList<ImportantData> listOfData = new
                BindingList<ImportantData>();

            public IBindingList BindingData =>
                listOfData; 
            public ReadOnlyCollection<ImportantData> CollectionOfData =>
                new ReadOnlyCollection<ImportantData>(listOfData);
            // other details elided
        }
    }
}
