﻿using System;
using static System.Console;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter2.OverridingBaseClasses
{
    public class Fruit { }
    public class Apple : Fruit { }

    public class Animal
    {
        public void Foo(Apple parm) =>
            WriteLine("In B.Foo");
    }

    public class Tiger : Animal
    {
        public void Foo(Fruit parm) =>
            WriteLine("In D.Foo");
    }

    public class Item19
    {
        public static void Tests()
        {
            var obj1 = new Animal();
            obj1.Foo(new Apple());


            var obj2 = new Tiger();
            obj2.Foo(new Apple());
            obj2.Foo(new Fruit());

            Animal obj3 = new Tiger();
            obj3.Foo(new Apple());

            var obj4 = new Tiger();
            ((Animal)obj4).Foo(new Apple());
            obj4.Foo(new Fruit());

        }
    }

    namespace SampleTwo
    {
        public class B
        {
            public void Foo(Apple parm) =>
                WriteLine("In B.Foo");

            public void Bar(Fruit parm) =>
                WriteLine("In B.Bar");
        }

        public class D : B
        {
            public void Foo(Fruit parm) =>
                WriteLine("In D.Foo");

            public void Bar(Fruit parm1, Fruit parm2 = null) =>
               WriteLine("In D.Bar");
        }


        public static class Testing
        {
            public static void Tests()
            {
                var obj1 = new D();
                obj1.Bar(new Apple());

            }
        }
    }

    namespace SampleThree
    {
        public class B
        {
            public void Foo(Apple parm) =>
                WriteLine("In B.Foo");

            public void Bar(Fruit parm) =>
                WriteLine("In B.Bar");

            public void Baz(IEnumerable<Apple> parm) =>
                WriteLine("In B.Foo2");
        }

        public class D : B
        {
            public void Foo(Fruit parm) =>
                WriteLine("In D.Foo");

            public void Bar(Fruit parm1, Fruit parm2 = null) =>
                WriteLine("In D.Bar");

                public void Baz(IEnumerable<Fruit> parm) =>
                    WriteLine("In D.Foo2");
        }

        public class PartThree
        {
            public static void Tests()
            {
                var sequence = new List<Apple> { new Apple(), new Apple() };
                var obj2 = new D();

                obj2.Baz(sequence);

            }
        }

    }

}
