﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter2
{
    public class WorkerEventArgs : EventArgs
    {
        public int Percent { get; set; }
        public bool Cancel { get; private set; }

        public void RequestCancel()
        {
            Cancel = true;
        }
    }

    public class WorkerEngine
    {
        public event EventHandler<WorkerEventArgs> OnProgress;
        public void DoLotsOfStuff()
        {
            for (int i = 0; i < 100; i++)
            {
                SomeWork();
                WorkerEventArgs args = new WorkerEventArgs();
                args.Percent = i;
                OnProgress?.Invoke(this, args);
                if (args.Cancel)
                    return;
            }
        }
        private void SomeWork()
        {
            // elided
        }
    }

    public class Item20
    {
    }
}
