﻿using System;
using static System.Console;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter2
{
    // Consider this the portion generated by your tool
    public partial class GeneratedStuff
    {
        private int storage = 0;

        public void UpdateValue(int newValue) =>
            storage = newValue;
    }

    public class Item23
    {
    }

    namespace Sample2
    {
        // Consider this the portion generated by your tool
        public partial class GeneratedStuff
        {
            private struct ReportChange
            {
                public readonly int OldValue;
                public readonly int NewValue;

                public ReportChange(int oldValue, int newValue)
                {
                    OldValue = oldValue;
                    NewValue = newValue;
                }
            }

            private class RequestChange
            {
                public ReportChange Values { get; set; }
                public bool Cancel { get; set; }
            }

            partial void ReportValueChanging(RequestChange args);
            partial void ReportValueChanged(ReportChange values);

            private int storage = 0;

            public void UpdateValue(int newValue)
            {
                // Precheck the change
                RequestChange updateArgs = new RequestChange
                {
                    Values = new ReportChange(storage, newValue)
                };
                ReportValueChanging(updateArgs);
                if (!updateArgs.Cancel) // if OK,
                {
                    storage = newValue; // change
                                        // and report:
                    ReportValueChanged(new ReportChange(
                        storage, newValue));
                }
            }

            // next Snippet. Change Method name.
            public void UpdateValueGet(int newValue)
            {
                RequestChange updateArgs = new RequestChange
                {
                    Values = new ReportChange(this.storage, newValue)
                };
                if (!updateArgs.Cancel)
                {
                    this.storage = newValue;
                }
            }

        }

        // This represents the hand-edited portion.
        public partial class GeneratedStuff
        {
            partial void ReportValueChanging(
                RequestChange args)
            {
                if (args.Values.NewValue < 0)
                {
                    WriteLine($@"Invalid value: {args.Values.NewValue}, canceling");
                    args.Cancel = true;
                }
                else
                    WriteLine($@"Changing {args.Values.OldValue} to {args.Values.NewValue}");
            }
            partial void ReportValueChanged(
                ReportChange values)
            {
                WriteLine($"Changed {values.OldValue} to {values.NewValue}");
            }
        }


    }

    namespace FinalSample
    {
        public partial class GeneratedStuff
        {
            int storage;

            // Hook for user-defined code:
            partial void Initialize();

            public GeneratedStuff() :
                this(0)
            {
            }

            public GeneratedStuff(int someValue)
            {
                this.storage = someValue;
                Initialize();
            }
        }
    }
}


