﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter5
{
    class Item46
    {

        public static void Tests()
        {
            var fullSequence = Enumerable.Range(1, 100);

            var processor = new Item46();

            var samples = processor.GenerateSample(fullSequence, -8);
            Console.WriteLine("Exception not thrown yet!");
            foreach (var item in samples) // exception thrwon here
            {
                Console.WriteLine(item);
            }
        }

        public IEnumerable<T> GenerateSample<T>(
            IEnumerable<T> sequence, int sampleFrequency)
        {
            if (sequence == null)
                throw new ArgumentException("Source seqeunce cannot be null", 
                    paramName: nameof(sequence));
            if (sampleFrequency < 1)
                throw new ArgumentException("Sample Frequency must be a positive integer",
                    paramName: nameof(sampleFrequency));

            int index = 0;
            foreach(T item in sequence)
            {
                if (index % sampleFrequency == 0)
                    yield return item;
            }
        }

        public IEnumerable<T> GenerateSampleFinal<T>(
            IEnumerable<T> sequence, int sampleFrequency)
        {
            if (sequence == null)
                throw new ArgumentException(
                    message: "Source seqeunce cannot be null",
                    paramName: nameof(sequence));
            if (sampleFrequency < 1)
                throw new ArgumentException(
                    message: "Sample Frequency must be a positive integer",
                    paramName: nameof(sampleFrequency));

            return generateSampleImpl();

            IEnumerable<T> generateSampleImpl()
            {
                int index = 0;
                foreach (T item in sequence)
                {
                    if (index % sampleFrequency == 0)
                        yield return item;
                }
            }
        }

        private MockDB context = new MockDB();

        public async Task<string> LoadMessage(string userName)
        {
            if (string.IsNullOrWhiteSpace(userName))
                throw new ArgumentException(
                    message: "This must be a valid user", 
                    paramName: nameof(userName));
            var settings = await context.LoadUser(userName);
            var message = settings.Message ?? "No message";
            return message;
        }

        public Task<string> LoadMessageFinal(string userName)
        {
            if (string.IsNullOrWhiteSpace(userName))
                throw new ArgumentException(
                    message: "This must be a valid user",
                    paramName: nameof(userName));

            return loadMessageImpl();

            async Task<string> loadMessageImpl()
            {
                var settings = await context.LoadUser(userName);
                var message = settings.Message ?? "No message";
                return message;
            }
        }

        public class MockDB
        {
            public Task<Settings> LoadUser(string user)
            {
                return Task.FromResult(new Settings());
            }
        }
        public class Settings
        {
            public string Message;
        }
    }
}
